export declare type ExternalStoreListenerType = () => void;
export declare type StateType<T = Record<string, any>> = T;
export declare type SetStateType<T> = (previous: T) => T;
export declare type ExternalStoreType<T> = {
    getState: () => T;
    setState: (fn: SetStateType<T>) => void;
    subscribe: (listener: ExternalStoreListenerType) => () => void;
};
export declare const useStore: <T>(store: ExternalStoreType<T>, propertyName: string) => T;
/**
 * https://blog.saeloun.com/2021/12/30/react-18-usesyncexternalstore-api
 */
export declare const createStore: <T>(initialState: T) => ExternalStoreType<T>;
